/*******************************************************************************
Copyright © 2024 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

window.TASK = {
	"code": "// Einige Variablen sind bereits deklariert\n// Es gab Wertezuweisungen\nif (x > 3) {\n    x = x - 1;\n}\nx = 2 + x;\nif (y >= x) {\n    y = y - x;\n} else {\n    y = x - y;\n}\nloesche = (y <= x / 2);\nif (loesche) {\n    x = 0;\n    y = 0;\n}",
	"notSelectable": [
		0,
		4,
		8,
		10,
		15
	],
	"steps": [
		{
			"task": "Da es hier nicht um Variablendeklaration und Zuweisung eines Startwertes geht, habe ich das bereits erledigt. Lass die Speichertabelle zunächst unverändert und wähle nun die nächste Zeile im Quelltext aus!",
			"line": 1,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 7
				},
				{
					"key": "y",
					"type": "int",
					"value": 5
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": false
				}
			],
			"allowArrays": false,
			"enableOverload": false,
			"autoremoveGarbage": false,
			"enableTextOut": false
		},
		{
			"task": "<p>Bei <code>if</code> wird der auf dieses Schlüsselwort folgende, in einer runden Klammer eingeschlossene Ausdruck ausgerechnet. Das Ergebnis muss ein Wahrheitswert sein. Beim Ergebnis <code>true</code> geht es mit der ersten Anweisung der inneren Sequenz weiter (also dem, was in geschweiften Klammern folgt). Beim Ergebnis <code>false</code> wird die innere Sequenz übersprungen.</p><p>Berechne nun anhand des Variablenwertes aus der Speichertabelle <code>x &gt; 3</code>. Klicke dann abhängig vom Ergebnis die Zeile an, mit der es weiter geht!</p>",
			"line": 2,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 7
				},
				{
					"key": "y",
					"type": "int",
					"value": 5
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": false
				}
			]
		},
		{
			"task": "Führe nun diese Wertezuweisung aus. Weil damit bereits die gesamte innere Sequenz des <code>if</code> erledigt ist, geht es mit der ersten Anweisung nach dieser inneren Sequenz weiter.",
			"line": 3,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 7
				},
				{
					"key": "y",
					"type": "int",
					"value": 5
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": false
				}
			]
		},
		{
			"task": "Führe nun diese Wertezuweisung aus. Weiter geht es mit der nächsten Zeile",
			"line": 5,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 6
				},
				{
					"key": "y",
					"type": "int",
					"value": 5
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": false
				}
			]
		},
		{
			"task": "<p>Noch ein <code>if</code>, diesmal aber mit einer zweiten inneren Sequenz nach dem Schlüsselwort <code>else</code>: Ergibt die <em>Bedingung</em> (also der Ausdruck in runden Klammern direkt nach <code>if</code>) <code>true</code>, wird die erste, direkt folgende innere Sequenz ausgeführt. Beim Ergebnis <code>false</code> hingegen die zweite, nach <code>else</code> folgende. In beiden Fällen geht es anschließend mit der Anweisung weiter, die nach der zweiten inneren Sequenz folgt.</p><p>Berechne also anhand der Werte in der Speichertabelle <code>y &gt;= x</code> und wähle dann entsprechend des Ergebnisses aus, in welcher Zeile es weiter geht!</p>",
			"line": 6,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 8
				},
				{
					"key": "y",
					"type": "int",
					"value": 5
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": false
				}
			]
		},
		{
			"task": "Wertezuweisung ausführen, dann weiter mit der ersten Anweisung nach dieser inneren Sequenz.",
			"line": 9,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 8
				},
				{
					"key": "y",
					"type": "int",
					"value": 5
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": false
				}
			]
		},
		{
			"task": "Weil ein Vergleich nur eine Berechnung ist, die einen Wahrheitswert ergibt, kann sie selbstverständlich auch in einer Wertezuweisung verwendet werden. <code>/</code> ist natürlich der Operator für die Division.",
			"line": 11,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 8
				},
				{
					"key": "y",
					"type": "int",
					"value": 3
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": false
				}
			]
		},
		{
			"task": "Wieder ein <code>if</code> ohne <code>else</code>: Nur wenn die Bedingung, also in diesem Fall die Variable <code>loesche</code> den Wert <code>true</code> hat, geht es mit der inneren Sequenz weiter. Andernfalls wird sie übersprungen.",
			"line": 12,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 8
				},
				{
					"key": "y",
					"type": "int",
					"value": 3
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": true
				}
			]
		},
		{
			"task": "Führe die Wertezuweisung aus. Weiter geht es natürlich mit der nächsten Anweisung dieser Sequenz.",
			"line": 13,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 8
				},
				{
					"key": "y",
					"type": "int",
					"value": 3
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": true
				}
			]
		},
		{
			"task": "Führe die Wertezuweisung aus. Weiter geht es natürlich mit der nächsten Anweisung nach dieser Sequenz.",
			"line": 14,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 0
				},
				{
					"key": "y",
					"type": "int",
					"value": 3
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": true
				}
			]
		},
		{
			"task": "Geschafft. Um dir zu zeigen, dass die Abarbeitung dieses Quelltextes von den Variablenwerten abhängt, machen wir das gleich nochmal. Wähle dazu nun wieder die allererste mögliche Zeile aus.",
			"line": "end",
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 0
				},
				{
					"key": "y",
					"type": "int",
					"value": 0
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": true
				}
			]
		},
		{
			"task": "Ändere nun den Wert von <code>y</code> einfach auf <code>4</code> und arbeite dann den Quelltext ab.",
			"line": 1,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 0
				},
				{
					"key": "y",
					"type": "int",
					"value": 0
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": true
				}
			]
		},
		{
			"task": "<p>Bei <code>if</code> wird der auf dieses Schlüsselwort folgende, in einer runden Klammer eingeschlossene Ausdruck ausgerechnet. Das Ergebnis muss ein Wahrheitswert sein. Beim Ergebnis <code>true</code> geht es mit der ersten Anweisung der inneren Sequenz weiter (also dem, was in geschweiften Klammern folgt). Beim Ergebnis <code>false</code> wird die innere Sequenz übersprungen.</p><p>Berechne nun anhand des Variablenwertes aus der Speichertabelle <code>x &gt; 3</code>. Klicke dann abhängig vom Ergebnis die Zeile an, mit der es weiter geht!</p>",
			"line": 2,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 0
				},
				{
					"key": "y",
					"type": "int",
					"value": 4
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": true
				}
			]
		},
		{
			"task": "Führe nun diese Wertezuweisung aus. Weil damit bereits die gesamte innere Sequenz des <code>if</code> erledigt ist, geht es mit der ersten Anweisung nach dieser inneren Sequenz weiter.",
			"line": 5,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 0
				},
				{
					"key": "y",
					"type": "int",
					"value": 4
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": true
				}
			]
		},
		{
			"task": "<p>Noch ein <code>if</code>, diesmal aber mit einer zweiten inneren Sequenz nach dem Schlüsselwort <code>else</code>: Ergibt die <em>Bedingung</em> (also der Ausdruck in runden Klammern direkt nach <code>if</code>) <code>true</code>, wird die erste, direkt folgende innere Sequenz ausgeführt. Beim Ergebnis <code>false</code> hingegen die zweite, nach <code>else</code> folgende. In beiden Fällen geht es anschließend mit der Anweisung weiter, die nach der zweiten inneren Sequenz folgt.</p><p>Berechne also anhand der Werte in der Speichertabelle <code>y &gt;= x</code> und wähle dann entsprechend des Ergebnisses aus, in welcher Zeile es weiter geht!</p>",
			"line": 6,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 2
				},
				{
					"key": "y",
					"type": "int",
					"value": 4
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": true
				}
			]
		},
		{
			"task": "Führe die Wertezuweisung aus. Anschließend geht es mit der ersten Anweisung weiter, die der nach <code>else</code> notierten inneren Sequenz folgt.",
			"line": 7,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 2
				},
				{
					"key": "y",
					"type": "int",
					"value": 4
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": true
				}
			]
		},
		{
			"task": "Führe die Wertezuweisung aus. Anschließend geht es mit der ersten Anweisung weiter, die der nach <code>else</code> notierten inneWeil ein Vergleich nur eine Berechnung ist, die einen Wahrheitswert ergibt, kann sie selbstverständlich auch in einer Wertezuweisung verwendet werden. <code>/</code> ist natürlich der Operator für die Division.ren Sequenz folgt.",
			"line": 11,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 2
				},
				{
					"key": "y",
					"type": "int",
					"value": 2
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": true
				}
			]
		},
		{
			"task": "Wieder ein <code>if</code> ohne <code>else</code>: Nur wenn die Bedingung, also in diesem Fall die Variable <code>loesche</code> den Wert <code>true</code> hat, geht es mit der inneren Sequenz weiter. Andernfalls wird sie übersprungen.",
			"line": 12,
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 2
				},
				{
					"key": "y",
					"type": "int",
					"value": 2
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": false
				}
			]
		},
		{
			"task": "Geschafft!",
			"line": "end",
			"vars": [
				{
					"key": "x",
					"type": "int",
					"value": 2
				},
				{
					"key": "y",
					"type": "int",
					"value": 2
				},
				{
					"key": "loesche",
					"type": "boolean",
					"value": false
				}
			]
		}
	]
};